// (C) Copyright 2009 Andreas Kloeckner

// Use, modification and distribution is subject to the Boost Software
// License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#ifndef BOOSTMPI_WRAP_HELPER_HPP
#define BOOSTMPI_WRAP_HELPER_HPP



#include <boost/python.hpp>




namespace boost { namespace mpi { namespace python {

  template <class Orig, class Wrapper>
  struct to_python_as_converter
  {
    static PyObject* convert(Orig const& s)
    {
      boost::python::object stage1 = 
        boost::python::object(Wrapper(s));
      PyObject *stage2(stage1.ptr());
      Py_INCREF(stage2);
      return stage2;
    }
  };

  template <class Orig, class Wrapper>
  inline void to_python_as()
  {
    boost::python::to_python_converter<Orig, 
      to_python_as_converter<Orig, Wrapper> >();
  }

} } }




#endif
