// (C) Copyright 2009 Andreas Kloeckner <inform -at- tiker.net>

// Use, modification and distribution is subject to the Boost Software
// License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

//  Authors: Andreas Kloeckner

#ifndef BOOST_MPI_WRAP_OPTIONAL_HPP
#define BOOST_MPI_WRAP_OPTIONAL_HPP

#include <boost/python.hpp>

template <class T>
struct optional_to_python
{
  static PyObject *convert(boost::optional<T> const &opt)
  {
    if (opt)
    {
      boost::python::object result(*opt);
      PyObject *py_result = result.ptr();
      Py_INCREF(py_result);
      return py_result;
    }
    else
      Py_RETURN_NONE;
  }
};

template <class T>
static void to_python_converter_for_optional()
{
  boost::python::to_python_converter<
    boost::optional<T>, 
    optional_to_python<T> >();
}

#endif
